<p align="center">
    <h1 align="center">PULSEQ INTERPRETATOR</h1>
</p>

## Оглавление/Quick Links

> - [ Обзор/Overview](#-overview)
> - [ Особенности/Features](#-features)
> - [ Подготовка / Getting Started](#-getting-started)
> - [ Установка/Installation](#-installation)


---

##  Обзор/Overview

Алгоритм для обработки специальных .seq файлов, содержащих импульсные последовательности, предназначен для создания последовательностей синхронизирующих импульсов для использования в аппарате магнитно-резонансной томографии (МРТ). 

---
Algorithm for processing special .seq files containing pulse sequences is designed for creating sequences of synchronizing pulses for use in magnetic resonance imaging (MRI) devices.

---

##  Особенности

1. Чтение .seq файла и извлечение информации о параметрах импульсов, таких как длительность, амплитуда, временные интервалы между импульсами и т.д.
2. Анализ полученных данных для определения оптимальной последовательности импульсов, обеспечивающей необходимую синхронизацию для проведения МРТ исследования.
3. Генерация нового файла с последовательностью синхронизирующих импульсов на основе анализа и оптимизации параметров.
4. Проверка сгенерированной последовательности на соответствие требованиям аппарата МРТ и корректировка при необходимости.
5. Экспорт окончательной последовательности импульсов для использования в работе с аппаратом МРТ.


## Features

1. Reading the .seq file and extracting information about pulse parameters, such as duration, amplitude, time intervals between pulses, etc.
2. Analyzing the obtained data to determine the optimal pulse sequence that ensures the necessary synchronization for conducting MRI research.
3. Generating a new file with the synchronizing pulse sequence based on the analysis and optimization of parameters.
4. Checking the generated sequence for compliance with the requirements of the MRI device and adjusting it if necessary.
5. Exporting the final pulse sequence for use in working with the MRI device.

---


## Подготовка / Getting Started

***Требования/Requirements***

chartio==6.0.1

matplotlib==3.8.4

numpy==1.26.4

pypulseq==1.4.0


### Установка/Installation

Клонируйте репозиторий/Clone the repository:

```sh
git clone https://git.physics.itmo.ru/cp.lab/MRI.git
```

Перейдите в директорию проекта/Change to the project directory:

```sh
cd cplab_copy
```

Установите требуемые пакеты/Install the required packages:

```sh
> pip install numpy==1.26.4
> pip install matplotlib==3.8.4
> pip install pypulseq==1.4.0
```

